//
//  ViewController.swift
//  Chapter 3 Photo Sharing
//
//  Created by Mini Projects on 14/05/2015.
//  Copyright (c) 2015 Packt Pub. All rights reserved.
//

import UIKit

class InitialViewController: UIViewController, UIImagePickerControllerDelegate, UINavigationControllerDelegate {
    
    var imagePicker = UIImagePickerController()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        imagePicker.delegate = self
        imagePicker.allowsEditing = false
    }

    @IBAction func takePhoto(sender: UIButton) {
        // You can't switch these 2 lines order, otherwise your app will crash.
        imagePicker.sourceType = .Camera
        imagePicker.cameraDevice = .Front
        
        imagePicker.cameraCaptureMode = .Photo
        imagePicker.videoQuality = .TypeMedium
        
        self.presentViewController(imagePicker, animated: true, completion: nil)
    }
    
    @IBAction func choosePhoto(sender: UIButton) {
        imagePicker.sourceType = .PhotoLibrary

        self.presentViewController(imagePicker, animated: true, completion: nil)
    }
    
    @IBAction func unwind(segue: UIStoryboardSegue){
        
    }
    
    // MARK: - Delegate functions
    func imagePickerController(picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [String : AnyObject]){
        imagePicker.dismissViewControllerAnimated(true, completion: { () -> Void in
            let image = info[UIImagePickerControllerOriginalImage] as! UIImage
            let editPictureViewController = self.storyboard?.instantiateViewControllerWithIdentifier("editphoto") as! EditPictureViewController
            editPictureViewController.photo = image
            self.presentViewController(editPictureViewController, animated: true, completion: nil)
        })
    }
    
    func imagePickerControllerDidCancel(picker: UIImagePickerController){
        imagePicker.dismissViewControllerAnimated(true, completion: nil)
    }
    


} // class end

