//
//  DoorLockViewController.swift
//  Chapter 4 Home Automation
//
//  Created by Mini Projects on 09/06/2015.
//  Copyright (c) 2015 Packt Pub. All rights reserved.
//

import Foundation
import UIKit
import HomeKit

class DoorLockViewController:AccessoryViewController{
    
    var value = false
    @IBOutlet var doorImage:UIImageView!
    override var expectedAccesory:String {
        return "Door Lock"
    }
    override var expectedService:String {
        return HMServiceTypeAccessoryInformation
    }
    override var expectedCharacteristic:String {
        return "EA7939D4-F26E-4F55-BCA0-6F0F6E6258BD"
    }
    
    @IBAction func toggleDoorLock(sender: UITapGestureRecognizer) {
        let newValue = !self.value
        characteristic?.writeValue(newValue, completionHandler: { (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.readCharacteristicValue()
        })
    }
    
    override func readCharacteristicValue() {
        characteristic?.readValueWithCompletionHandler({ (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.value = self.characteristic?.value as! Bool
            switch self.value {
            case true:
                self.doorImage.image = UIImage(named: "doorclosed")
            case false:
                self.doorImage.image = UIImage(named: "dooropen")
            }
        })
    }
} // end class
