//
//  FanViewController.swift
//  Chapter 4 Home Automation
//
//  Created by Mini Projects on 09/06/2015.
//  Copyright (c) 2015 Packt Pub. All rights reserved.
//

import Foundation
import UIKit
import HomeKit

class FanViewController:AccessoryViewController {
    var value = false
    @IBOutlet var fanImage:UIImageView!
    @IBOutlet var fanSwitch: UISwitch!
    override var expectedAccesory:String {
        return "Fan"
    }
    override var expectedService:String {
        return HMServiceTypeFan
    }
    override var expectedCharacteristic:String {
        return HMCharacteristicTypePowerState
    }
    
    @IBAction func toggleFanSwitch(sender: UISwitch) {
        let newValue = sender.on
        characteristic?.writeValue(newValue, completionHandler: { (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.readCharacteristicValue()
        })
    }
    
    override func readCharacteristicValue() {
        characteristic?.readValueWithCompletionHandler({ (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.value = self.characteristic?.value as! Bool
            self.fanSwitch.on = self.value
            if self.value {
                self.rotateFan()
            }
        })
    }
    
    private func rotateFan(){
        UIView.animateWithDuration(NSTimeInterval(0.2), delay: NSTimeInterval(0.0), options: UIViewAnimationOptions.CurveLinear, animations: {
            self.fanImage.transform = CGAffineTransformRotate(self.fanImage.transform, CGFloat(M_PI / 2))
            
            }, completion: { (finished) -> Void in
                if self.value {

                    self.rotateFan()
                }
        })
    }
} // end class
