//
//  GarageDoorViewController.swift
//  Chapter 4 Home Automation
//
//  Created by Mini Projects on 03/06/2015.
//  Copyright (c) 2015 Packt Pub. All rights reserved.
//

import UIKit
import HomeKit

class GarageDoorViewController:AccessoryViewController{
    
    var value = false
    @IBOutlet var garageImage:UIImageView!
    override var expectedAccesory:String {
            return "Garage Door"
    }
    
    override var expectedService:String {
        return HMServiceTypeGarageDoorOpener
    }
    
    override var expectedCharacteristic:String {
        return HMCharacteristicTypeTargetDoorState
    }
    
    @IBAction func toggleGarageDoor(sender: UITapGestureRecognizer) {
        let newValue = !self.value
        characteristic?.writeValue(newValue, completionHandler: { (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.readCharacteristicValue()
        })
    }
    
    override func readCharacteristicValue() {
        characteristic?.readValueWithCompletionHandler({ (error) -> Void in
            if error != nil {
                self.displayError(error!)
                return
            }
            self.value = self.characteristic?.value as! Bool
            switch self.value {
            case true:
                self.garageImage.image = UIImage(named: "garageclosed")
            case false:
                self.garageImage.image = UIImage(named: "garageopen")
            }
        })
    }

} // end class
