//
//  LivingRoomViewController.swift
//  Chapter 4 Home Automation
//
//  Created by Mini Projects on 09/06/2015.
//  Copyright (c) 2015 Packt Pub. All rights reserved.
//

import Foundation
import UIKit
import HomeKit

class LivingRoomViewController: UIPageViewController, UIPageViewControllerDataSource{
    
    var home:HMHome!
    var room:HMRoom!
    var accessoryViewControllers = [AccessoryViewController]()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // View Controllers
        let doorLock = self.storyboard?.instantiateViewControllerWithIdentifier("doorlockviewcontroller") as! DoorLockViewController
        doorLock.room = self.room
        doorLock.home = self.home
        self.accessoryViewControllers.append(doorLock)
        
        let fan = self.storyboard?.instantiateViewControllerWithIdentifier("fanviewcontroller") as! FanViewController
        fan.room = self.room
        fan.home = self.home
        self.accessoryViewControllers.append(fan)
        
        let aquarium = self.storyboard?.instantiateViewControllerWithIdentifier("aquariumviewcontroller") as! AquariumViewController
        aquarium.room = self.room
        aquarium.home = self.home
        self.accessoryViewControllers.append(aquarium)
        
        self.setViewControllers([doorLock], direction: .Forward, animated: false, completion: nil)        
        self.dataSource = self
        
        // Page control
        let pageControl = UIPageControl.appearance()
        pageControl.pageIndicatorTintColor = UIColor.lightGrayColor()
        pageControl.currentPageIndicatorTintColor = UIColor.blackColor()
        pageControl.backgroundColor = UIColor.whiteColor()
        
    }
    
    // MARK: - Data source methods
    
    func pageViewController(pageViewController: UIPageViewController, viewControllerBeforeViewController viewController: UIViewController) -> UIViewController?{
        if let index = self.accessoryViewControllers.indexOf( viewController as! AccessoryViewController) where index > 0  {
            return self.accessoryViewControllers[index - 1]
        }
        return nil
    }
    func pageViewController(pageViewController: UIPageViewController, viewControllerAfterViewController viewController: UIViewController) -> UIViewController?{
        if let index = self.accessoryViewControllers.indexOf( viewController as! AccessoryViewController) where index < self.accessoryViewControllers.count - 1 {
            return self.accessoryViewControllers[index + 1]
        }
        return nil
        
    }
    
    func presentationCountForPageViewController(pageViewController: UIPageViewController) -> Int {
        // how many bullets should be displayed
        return accessoryViewControllers.count
    }
    
    func presentationIndexForPageViewController(pageViewController: UIPageViewController) -> Int {
        // position we start
        return 0
    }
} // end class
