//
//  ViewController.swift
//  Chapter 5 HealthKit
//
//  Created by Mini Projects on 14/06/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import UIKit
import HealthKit

class InitialViewController: UIViewController {

    @IBOutlet var buttons: [UIButton]!
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        
        let healthKitStore:HKHealthStore = HKHealthStore()
        let weightQuantityType = HKQuantityType.quantityTypeForIdentifier(
            HKQuantityTypeIdentifierBodyMass)!
        let heartRateQuantityType = HKQuantityType.quantityTypeForIdentifier(
            HKQuantityTypeIdentifierHeartRate)!
        let stepCountType = HKQuantityType.quantityTypeForIdentifier(HKQuantityTypeIdentifierStepCount)!
        
        if !HKHealthStore.isHealthDataAvailable() {
            self.displayError("Health data is not available")
            return
        }
        
        let typesToShare = Set<HKSampleType>([weightQuantityType])
        let typesToRead = Set<HKObjectType>([weightQuantityType, heartRateQuantityType, stepCountType])
        
        healthKitStore.requestAuthorizationToShareTypes(typesToShare, readTypes: typesToRead) { success, error in
            M{
                if let error = error  {
                    self.displayError(error.localizedDescription)
                }else if success {
                    for button in self.buttons {
                        button.enabled = true
                    }
                }
                else {
                    self.displayError("Authorization not successful")
                }
            }
        }
    } // end viewDidAppear

}// end class

