//
//  GlanceController.swift
//  Chapter 7 Fridge Control WatchKit Extension
//
//  Created by Mini Projects on 13/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import WatchKit
import Foundation
import WatchConnectivity


class GlanceController: WKInterfaceController, WCSessionDelegate {


    @IBOutlet var drinkLabel: WKInterfaceLabel!
    @IBOutlet var foodLabel: WKInterfaceLabel!
    @IBOutlet var dessertLabel: WKInterfaceLabel!
    
    override func awakeWithContext(context: AnyObject?) {
        super.awakeWithContext(context)
        
        // Configure interface objects here.
    }

    override func willActivate() {
        // This method is called when watch view controller is about to be visible to user
        super.willActivate()
        if (WCSession.isSupported()) {
            let session = WCSession.defaultSession()
            session.delegate = self
            session.activateSession()
            
            session.sendMessage(["request":"status", "type":"drink"],
                replyHandler: { (reply) -> Void in
                    dispatch_async(dispatch_get_main_queue(), { () -> Void in
                        let percentage = Int(reply["value"] as! Float * 100.0)
                        self.drinkLabel.setText("Drink \(percentage)%")
                    })
                },
                errorHandler: { (error) -> Void in
                    print(error.localizedDescription)
            })
            
            session.sendMessage(["request":"status", "type":"food"],
                replyHandler: { (reply) -> Void in
                    dispatch_async(dispatch_get_main_queue(), { () -> Void in
                        let percentage = Int(reply["value"] as! Float * 100.0)
                        self.foodLabel.setText("Food \(percentage)%")
                    })
                },
                errorHandler: { (error) -> Void in
                    print(error.localizedDescription)
            })
            
            session.sendMessage(["request":"status", "type":"dessert"],
                replyHandler: { (reply) -> Void in
                    dispatch_async(dispatch_get_main_queue(), { () -> Void in
                        let percentage = Int(reply["value"] as! Float * 100.0)
                        self.dessertLabel.setText("Dessert \(percentage)%")
                    })
                },
                errorHandler: { (error) -> Void in
                    print(error.localizedDescription)
            })
        }
    }

    override func didDeactivate() {
        // This method is called when watch view controller is no longer visible
        super.didDeactivate()
    }

}
