//
//  InterfaceController.swift
//  Chapter 7 Fridge Control WatchKit Extension
//
//  Created by Mini Projects on 13/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import WatchKit
import Foundation


class InterfaceController: WKInterfaceController {
    
    @IBOutlet var statusTable: WKInterfaceTable!
    var rowsInfo = [RowInfo]()

    override func awakeWithContext(context: AnyObject?) {
        super.awakeWithContext(context)
        var rowInfo = RowInfo(title: "Drink", image:  "drink", key: "drink")
        rowsInfo.append(rowInfo)
        rowInfo = RowInfo(title: "Food", image: "food", key: "food")
        rowsInfo.append(rowInfo)
        rowInfo = RowInfo(title: "Dessert", image: "dessert", key: "dessert")
        rowsInfo.append(rowInfo)
        
        statusTable.setNumberOfRows(rowsInfo.count, withRowType: "supplyrow")
        for i in 0..<statusTable.numberOfRows {
            let row = statusTable.rowControllerAtIndex(i) as! SupplyRow
            let rowInfo = rowsInfo[i]
            row.caption.setText(rowInfo.title)
            let image = UIImage(named: rowInfo.title)
            row.image.setImage(image)
        }
    }
    
    override func contextForSegueWithIdentifier(segueIdentifier: String, inTable table: WKInterfaceTable, rowIndex: Int) -> AnyObject? {
        if segueIdentifier == "supplysegue" {
            return rowsInfo[rowIndex]
        }
        return nil
    }

    override func willActivate() {
        
        // This method is called when watch view controller is about to be visible to user
        super.willActivate()
        
    }

    override func didDeactivate() {
        // This method is called when watch view controller is no longer visible
        super.didDeactivate()
    }

}
