//
//  MapInterfaceController.swift
//  Chapter 7 Fridge Control
//
//  Created by Mini Projects on 28/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import Foundation
import WatchKit

class MapController: WKInterfaceController {
    
    @IBOutlet var map: WKInterfaceMap!
    var supermarketData:[String:AnyObject]!
    override func awakeWithContext(context: AnyObject?) {
        self.supermarketData = context as! [String:AnyObject]
    }
    
    override func willActivate() {
        let latitude = self.supermarketData["latitude"] as! Double
        let longitude = self.supermarketData["longitude"] as! Double
        let location = CLLocationCoordinate2D(latitude: latitude, longitude: longitude)
        map.addAnnotation(location, withPinColor: .Purple)
        let region = MKCoordinateRegion(center: location, span: MKCoordinateSpan(latitudeDelta: 0.005, longitudeDelta: 0.005))
        self.map.setRegion(region)
    }
} // end MapController