//
//  AppDelegate.swift
//  Chapter 7 Fridge Control
//
//  Created by Mini Projects on 13/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import UIKit
import WatchConnectivity

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate, WCSessionDelegate{

    var window: UIWindow?

    func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool {
        
        let session = WCSession.defaultSession()
        session.delegate = self
        session.activateSession()
        
        return true
    }


    func applicationWillResignActive(application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }
    
    
    func applicationDidReceiveMemoryWarning(application: UIApplication) {
        Fridge.mainFridge().compress()
    }
    
    @available(iOS 9.0, *)
    func session(session: WCSession, didReceiveMessage message: [String : AnyObject], replyHandler: ([String : AnyObject]) -> Void){
        
        if let request = message["request"] as? String {
            switch request{
            case "status":
                let fridge = Fridge.mainFridge()
                let type = message["type"] as! String
                let status = fridge.cyclePercentageFor(SupplyType(rawValue: type)!)
                replyHandler(["response": "status",
                    "value": status])
            case "supermarket":
                let supermarket = Supermarket.defaultSupermarket()
                if let address = supermarket.address,
                    latitude = supermarket.latitude,
                    longitude = supermarket.longitude {
                        replyHandler(["response": "supermarket",
                            "value":["address": address,
                            "latitude": latitude,
                            "longitude": longitude]])
                }else {
                    replyHandler(["response": "unavailable"])
                }
            default:
                replyHandler(["response": "notfound"])
            }// end switch
        }// end if
    } // end didReceiveMessage

}

