//
//  ViewController.swift
//  Chapter 7 Fridge Control
//
//  Created by Mini Projects on 13/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import UIKit


class InitialViewController: UIViewController {
    
    var timer:NSTimer?
    var fridge = Fridge.mainFridge()
    let interval = 5.0

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func unwindToInitialViewController(segue:UIStoryboardSegue)
    {
        if segue.sourceViewController is AddSuppliesViewController {
            if timer === nil {
                timer = NSTimer.scheduledTimerWithTimeInterval(interval, target: self, selector: Selector("tick"), userInfo: nil, repeats: true)
            }
        }
    }

    func tick(){
        print("TICK \(NSDate())")
        self.fridge.consume(UInt(interval))
        for key in self.fridge.notified.keys {
            if let notified = fridge.notified[key] where !notified && fridge.remainingTime(key) < UInt(Fridge.cycleThreshold * Double(Fridge.cycleTime * Fridge.cycleUnit)) {
                print("notified for \(key)")
                fridge.notified[key] = true
                let localNotification = UILocalNotification()
                localNotification.fireDate = NSDate()
                localNotification.alertBody = "NOOOOO FOOD"
                localNotification.timeZone = NSTimeZone.defaultTimeZone()
                UIApplication.sharedApplication().scheduleLocalNotification(localNotification)
            }
        }
    }
    
    
}

