//
//  Supply.swift
//  Chapter 7 Fridge Control
//
//  Created by Mini Projects on 17/07/2015.
//  Copyright © 2015 Packt Pub. All rights reserved.
//

import Foundation

enum SupplyType:String{
    case Drink = "drink", Food = "food", Dessert = "dessert"
}

class Supply {
    
    var name:String
    var type:SupplyType
    private var duration:UInt
    private var consumed:UInt = 0
    
    init(name:String, type:SupplyType, duration:UInt) {
        self.name = name
        self.type = type
        self.duration = duration
    }
    
    func consume(seconds: UInt) -> UInt{
        if consumed + seconds > duration {
            let rest:UInt = seconds - (duration - consumed)
            consumed = duration
            return rest
        }
        consumed += seconds
        return 0
    }
    
    func endEstimation() -> UInt {
        return duration - consumed
    }
    
}

