//
//  AssetInfo.swift
//  Chapter 8 Rehash
//
//  Created by City Life on 15/08/2015.
//  Copyright © 2015 PacktPub. All rights reserved.
//

import Foundation
import UIKit


class AssetInfo {
    var videoThumbnail:UIImage?
    
    var videoDate:String
    var videoUrl:NSURL
    
    init(videoDate:String, videoUrl:NSURL){
        self.videoDate = videoDate
        self.videoUrl = videoUrl
    }
    
    let audioFilename = "rehash.m4a"
    var audioPath:String? {
        didSet {
            if let audioPath = self.audioPath {
                self.audioUrl = NSURL(fileURLWithPath: audioPath)
            }else {
                self.audioUrl = nil
            }
        }
    }
    var audioUrl:NSURL?
    
    func prepareAudio() throws -> NSURL? {
        let fileManager = NSFileManager.defaultManager()
        let globallyUniqueString = NSProcessInfo.processInfo().globallyUniqueString
        let tempPath = (NSTemporaryDirectory() as NSString).stringByAppendingPathComponent(globallyUniqueString)
        try fileManager.createDirectoryAtPath(tempPath, withIntermediateDirectories: false, attributes: nil)
        self.audioPath = (tempPath as NSString).stringByAppendingPathComponent(self.audioFilename)
        print("The full audio path is \(audioPath))")
        return self.audioUrl
    }
    
    deinit {
        let fileManager = NSFileManager.defaultManager()
        do {
            if let audioPath = self.audioPath {
                try fileManager.removeItemAtPath(audioPath)
            }
        } catch {
            print("Couldn't delete \(self.audioPath!) on file \(__FILE__) at line \(__LINE__)")
        }
    }
    
} // end class AssetInfo
